/*
 *  MIDIMnpDemo.c
 *  
 *
 *  Created by Kentaro Ueda on Thu Jun 20 2002.
 *  Copyright (c) 2002 Kentaro Ueda. All rights reserved.
 *
 */

#include <stdio.h>
#include "SMFdefine.h"
#include "SMFIn.h"
#include "MIDIMnp.h"

int MIDIMnpDemo(void);
int MIDIMnpDemo(void){

	Midis		*MidiData;
	Metas	*MetaData;
	long		MidiDataNum;
	long		MetaDataNum;
	short		granulality;
	short		s=0,s1=0;
	FILE		*fp;
	
	Notes	*NoteData;
	long		NoteDataNum;

/*MIDIMnp Demonstration*/
	fp=fopen("test1.mid","rb");
	if(SMFIn(fp,&MidiData,&MetaData,&MidiDataNum,&MetaDataNum,&granulality)==-1){
		printf("SMF_In is failed!\n");
		return false;
	}
	fclose(fp);
	printf("\nMidiDataSort Demonstration\n");
	MIDIDataSort(MidiDataNum,&MidiData);
	printf("MIDI-Data is ...\n");
	for(s=0;s<MidiDataNum;s++){
		if((MidiData[s].status == 0xF0)||(MidiData[s].status == 0xF7)){
			printf("%d status=%X,exclusiveLength=%d,timestamp=%ld	",s,MidiData[s].status,MidiData[s].exclusiveLength,MidiData[s].timestamp);
			printf("ExclusiveData = ",MidiData[s].exclusiveData);
			for(s1=0;s1<MidiData[s].exclusiveLength;s1++)
				printf("%X ",MidiData[s].exclusiveData[s1]);
			printf("\n");
		}
		else
			printf("%d status=%X,note=%d,velocity=%d,timestamp=%ld\n",s,MidiData[s].status,MidiData[s].note,MidiData[s].velocity,MidiData[s].timestamp);
	}
	
	printf("\nCheckNoteOn Demonstration\n");
	for(s=0;s<MidiDataNum;s++)
		if(CheckNoteOn(MidiData[s].status,MidiData[s].velocity))	printf("%d's MIDI-Data is note_on!\n",s);

	printf("\nCheckNoteOff Demonstration\n");
	for(s=0;s<MidiDataNum;s++)
		if(CheckNoteOff(MidiData[s].status,MidiData[s].velocity))	printf("%d's MIDI-Data is note_off!\n",s);

	printf("\nCouplingNoteData Demonstration\n");
	CouplingNoteData(MidiData,MidiDataNum, &NoteData, &NoteDataNum);
	for(s=0;s<NoteDataNum;s++)
		printf("%d	channel=%d pitch=%d velocity=%d StartTime=%ld FinishTime=%ld\n",s,NoteData[s].channel,NoteData[s].pitch,NoteData[s].velocity,NoteData[s].StartTime,NoteData[s].FinishTime);
	free(NoteData);

	FinishSMFIn(&MidiData,&MetaData,MidiDataNum,MetaDataNum);

	return true;
}
