/*
 *  MetaMnp.h
 *  
 *
 *  Created by Kentaro Ueda on Thu Jun 20 2002.
 *  Copyright (c) 2002 Kentaro Ueda. All rights reserved.
 *
 */

#include <stdlib.h>
#include <string.h>
#include "SMFdefine.h"

#ifndef __MetaMnp__
#define __MetaMnp__

/*for MetaMnpFunction*/
#define	MetaMnpErr	-1
#define	true		1

/*for MetaEvent Number*/
#define	MetaSequenceNumber	0x00
#define	MetaText		0x01
#define	MetaCopyright		0x02
#define	MetaSequenceTrackName	0x03
#define	MetaInstrument		0x04
#define	MetaLyric		0x05
#define	MetaMarker		0x06
#define	MetaCuePoint		0x07
#define	MetaMIDIChannelPrefix	0x20
#define	MetaSelectPort		0x21
#define	MetaTrackEnd		0x2F
#define	MetaSetTempo		0x51
#define	MetaSMPTEOffset		0x54
#define	MetaTimeSignature	0x58
#define	MetaKeySignature	0x59
#define	MetaSequencerSpecific	0x7F
/*for KeySignature*/
#define CM	0
#define DbM	1
#define DM	2
#define EbM	3
#define EM	4
#define FM	5
#define GbM	6
#define GM	7
#define AbM	8
#define AM	9
#define BbM	10
#define BM	11

#define Cm	12
#define Dbm	13
#define Dm	14
#define Ebm	15
#define Em	16
#define Fm	17
#define Gbm	18
#define Gm	19
#define Abm	20
#define Am	21
#define Bbm	22
#define Bm	23

#endif

/*Function*/
extern int MetaDataSort(long MetaDataNum, Metas **MetaData);
extern float MetaDataToBPM(Metas MetaData);
extern int MetaDataToTimeSignature(Metas MetaData,short *denominator,short *numerator);
extern int MetaDataToKeySignatureNum(Metas MetaData);
extern int MetaDataToKeySignatureStr(Metas MetaData,char Key[4]);