/*
 *  MetaMnpDemo.c
 *  
 *
 *  Created by Kentaro Ueda on Thu Jun 20 2002.
 *  Copyright (c) 2002 Kentaro Ueda. All rights reserved.
 *
 */

#include <stdio.h>
#include "SMFdefine.h"
#include "SMFIn.h"
#include "MetaMnp.h"

int MetaMnpDemo(void);
int MetaMnpDemo(void){

	Midis		*MidiData;
	Metas	*MetaData;
	long		MidiDataNum;
	long		MetaDataNum;
	short		granulality;
	short		s=0,s1=0;
	FILE		*fp;
	
	float		BPM;
	short		denominator,numerator;
	int		key;
	char		Key[4];
	
/*MetaMno Demonstration*/
	fp=fopen("test1.mid","rb");
	if(SMFIn(fp,&MidiData,&MetaData,&MidiDataNum,&MetaDataNum,&granulality)==-1){
		printf("SMF_In is failed!\n");
		return false;
	}
	fclose(fp);
	
	for(s=0;s<MetaDataNum;s++){
		switch(MetaData[s].num){
			case MetaText:
				printf("timestamp = %ld, Type = MetaText, data = ",MetaData[s].timestamp);
				for(s1=0;s1<MetaData[s].length;s1++)
					printf("%c",MetaData[s].data[s1]);
				printf("\n");
				break;
			case MetaCopyright:
				printf("timestamp = %ld, Type = MetaCopyright, data = ",MetaData[s].timestamp);
				for(s1=0;s1<MetaData[s].length;s1++)
					printf("%c",MetaData[s].data[s1]);
				printf("\n");
				break;
			case MetaSequenceTrackName:
				printf("timestamp = %ld, Type = MetaSequenceTrackName, data = ",MetaData[s].timestamp);
				for(s1=0;s1<MetaData[s].length;s1++)
					printf("%c",MetaData[s].data[s1]);
				printf("\n");
				break;
			case MetaInstrument:
				printf("timestamp = %ld, Type = MetaInstrument, data = ",MetaData[s].timestamp);
				for(s1=0;s1<MetaData[s].length;s1++)
					printf("%c",MetaData[s].data[s1]);
				printf("\n");
				break;
			case MetaLyric:
				printf("timestamp = %ld, Type = MetaLyric, data = ",MetaData[s].timestamp);
				for(s1=0;s1<MetaData[s].length;s1++)
					printf("%c",MetaData[s].data[s1]);
				printf("\n");
				break;
			case MetaSetTempo:
				BPM = MetaDataToBPM(MetaData[s]);
				printf("timestamp = %ld, BPM = %f\n",MetaData[s].timestamp,BPM);
				break;
			case MetaTimeSignature:
				MetaDataToTimeSignature(MetaData[s], &denominator, &numerator);
				printf("timestamp = %ld, TimeSignature = %d/%d\n",MetaData[s].timestamp,numerator,denominator);
				break;
			case MetaKeySignature:
				key=MetaDataToKeySignatureNum(MetaData[s]);
				MetaDataToKeySignatureStr(MetaData[s],Key);
				printf("timestamp = %ld, Keynum = %d, Key = %s\n",MetaData[s].timestamp,key,Key);
				break;
			default:
				break;
		}
	}

	FinishSMFIn(&MidiData,&MetaData,MidiDataNum,MetaDataNum);

	return true;
}
