/*
 *  SMFIn.c
 *  
 *
 *  Created by Kentaro Ueda on Thu Jun 20 2002.
 *  Copyright (c) 2002 Kentaro Ueda. All rights reserved.
 *
 */

#include <stdlib.h>
#include <string.h>
#include "SMFdefine.h"
#include "SMFIn.h"
#include "TrackDataMnp.h"

int ReadHeaderInf(FILE *fp,short *format,short *TrackNum,short *Granulality);
int ReadTrackData(FILE *fp,char **TrackData,unsigned long *TrackLength);
extern int SMFIn(FILE *fp,Midis *MidiData[],Metas *MetaData[],long *MidiDataNum,long *MetaDataNum,short *Granulality);
extern int FinishSMFIn(Midis **MidiData,Metas **MetaData,long MidiDataNum,long MetaDataNum);

int ReadHeaderInf(FILE *fp,short *format,short *TrackNum,short *Granulality){

	long	length;
	char	data[5];
	
	/*read MThd*/
	length = 5;
	if(strcmp("MThd",fgets(data,length,fp)))
		return SMFDataErr;	
	/*read header length(=6)*/
	length = 5;
	fgets(data,length,fp);
	if(data[3]!=6)
		return SMFDataErr;	
	/*read format*/
	length = 3;
	fgets(data,length,fp);
	*format = (short)data[1];
	/*read track number*/			
	length = 3;
	fgets(data,length,fp);
	*TrackNum = (short)data[1];
	/*read Granulality*/
	length = 3;
	fgets(data,length,fp);
	*Granulality = (short)((data[0] << 8) + (0xFF&data[1]));
	
	return true;
}

int ReadTrackData(FILE *fp,char **TrackData,unsigned long *TrackLength){

	long	length;
	char	data[5];
	
	/*read MTrk*/
	length = 5;
	if(strcmp("MTrk",fgets(data,length,fp)))
		return SMFDataErr;
	/*read TrackLength*/		
	length = 5;fgets(data,length,fp);					
	(*TrackLength)= (unsigned long)((data[0] <<24) + (0xFF0000&(data[1]<<16)) + (0xFF00&(data[2]<<8)) + (0xFF&(data[3])));
	/*malloc TrackData*/
	(*TrackData) = (char*)malloc(((*TrackLength)+10)*(sizeof(char)));	
	if((*TrackData )==NULL)
		return MemoryErr;
	/*read TrackData*/
	if((*TrackLength) != fread((*TrackData),sizeof(char),(*TrackLength),fp))		return SMFDataErr;
	
	return true;
}

extern int SMFIn(FILE *fp,Midis *MidiData[],Metas *MetaData[],long *MidiDataNum,long *MetaDataNum,short *Granulality){

    short		TrackNumber=0,TrackCounter;
    unsigned long	TrackLength = 0;	
    char		*TrackData;
    short		format;
    int			Err;

    *MidiDataNum = 0;
    *MetaDataNum=0;
	/***************************Initialize*******************************************/
	if(!ReadHeaderInf(fp,&format,&TrackNumber,Granulality))
		return SMFDataErr;
	for(TrackCounter=0;TrackCounter<TrackNumber;TrackCounter++){
		Err=ReadTrackData(fp,&TrackData,&TrackLength);
		if(!Err)
			return Err;
		CountDataNumber(TrackData, TrackLength, MidiDataNum, MetaDataNum);
		free(TrackData);
	}
	if(fseek(fp,0,SEEK_SET))
		return false;
	
	/*malloc MIDI data*/
	(*MidiData) = (Midis*)malloc((sizeof (Midis))*(*MidiDataNum));
	if ((*MidiDataNum) != 0)
		if((*MidiData)==NULL)
			return MemoryErr;
	/*malloc Meta data*/        			
	(*MetaData) = (Metas*)malloc((sizeof (Metas))*(*MetaDataNum));
	if((*MetaDataNum) != 0)
		if((*MetaData)==NULL)
			return MemoryErr;
	
	*MetaDataNum = 0;
	*MidiDataNum = 0;
/****************************Read MIDI&MetaData*************************************/
    if(!ReadHeaderInf(fp,&format,&TrackNumber,Granulality))	return SMFDataErr;
    for(TrackCounter=0;TrackCounter<TrackNumber;TrackCounter++){
        Err=ReadTrackData(fp,&TrackData,&TrackLength);
        if(!Err)
		return Err;
	Err=TrackDataOut(TrackData,TrackLength,MidiData,MetaData,MidiDataNum,MetaDataNum);
        if(!Err)
		return Err;
        free(TrackData);
    }

    return format;
}

extern int FinishSMFIn(Midis **MidiData,Metas **MetaData,long MidiDataNum,long MetaDataNum){
	if (MidiDataNum != 0)	free(*MidiData);
	if (MetaDataNum != 0)	free(*MetaData);
	
	return true;
}