/*
 *  SMFOut.c
 *  
 *
 *  Created by Kentaro Ueda on Thu Jun 20 2002.
 *  Copyright (c) 2002 Kentaro Ueda. All rights reserved.
 *
 */

#include <stdlib.h>
#include <string.h>
#include "SMFdefine.h"
#include "SMFOut.h"
#include "TrackDataMnp.h"

int midiDataSort(long MidiDataNum, Midis *MidiData[]);

extern int SMFOut(FILE *fp,Midis MidiData[],Metas MetaData[],long MidiDataNum,long MetaDataNum,short Granulality,int format);
int WriteHeaderInf(FILE *fp,int format,short TrackNum,short Granulality);

int WriteHeaderInf(FILE *fp,int format,short TrackNum,short Granulality){
	
	char	data[5];
	
	/*write MThd*/
	strcpy(data,"MThd");							
	fwrite(data,sizeof(char),4,fp);	
	/*write "0006"*/
	strcpy(data,"\0");							
	fwrite(data,sizeof(char),1,fp);	
	strcpy(data,"\0");							
	fwrite(data,sizeof(char),1,fp);	
	strcpy(data,"\0");							
	fwrite(data,sizeof(char),1,fp);
	strcpy(data,"\6");							
	fwrite(data,sizeof(char),1,fp);
	/*write format*/
	data[0]=0;data[1]=(char)format;					
	fwrite(data,sizeof(char),2,fp);	
	/*write track number*/
	data[0]=0;data[1]=(char)TrackNum;				
	fwrite(data,sizeof(char),2,fp);	
	/*write Granulaity*/
	data[0]=(char)(Granulality>>8);data[1]=(char)(0xFF&Granulality);
	fwrite(data,sizeof(char),2,fp);	
	
	return true;
}

extern int SMFOut(FILE *fp,Midis MidiData[],Metas MetaData[],long MidiDataNum,long MetaDataNum,short Granulality,int format){

	short		TrackNum=1;
	short		TrackCounter;
	MMDatas		*MMData;
	char		*TrackData;
	unsigned long	TrackLength;
	int			Err;

/*	Not supported format 1 yet*/
    if(format != 0)	return formatErr;
    
    WriteHeaderInf(fp,format,TrackNum,Granulality);

    for(TrackCounter=0;TrackCounter<TrackNum;TrackCounter++){
        Err = MixMIDIandMetaData(MidiData,MetaData,MidiDataNum,MetaDataNum,&MMData,&TrackLength);
        if(Err != true)	
        	return Err;
        Err = MakeTrackData(&TrackData,MidiData,MetaData,MidiDataNum,MetaDataNum,MMData,TrackLength);
        if(Err != true)
        	return Err;
        fwrite(TrackData,sizeof(char),TrackLength+4+4,fp);
    }
    
    free(MMData);
    
    return true;
}